//doorslocked.c
//
//Shigor Birdman
//
//simple doors script - they are locked until UNLOCKGV global variable is set - this is one time use unlock!


#include <inc\sc_global.h>
#include <inc\sc_def.h>

#define OPENINGTIME 		0.5f				//how long will be the doors opening
#define AUTOCLOSETIME 		2				//how long it will take to autoclose the door?
#define AUTOCLOSEDISTANCE	15				//minimal distance from the player to activate the autoclose
#define CLOSESTRING 		2814				//what text will be shown when pointing at the the open doors?	- "to open the door"
#define OPENSTRING		2813				//what text will be shown when pointing at the the closed  doors? - "to close the door"
#define CLOSESOUND		2002				//sound of the closing doors
#define OPENSOUND		2001				//sound of the opening doors
#define UNLOCKGV		SGI_ARRIVAL_UNLOCKED		//which global variable unlocks the door



s_SC_NOD_transform orig_trans;
BOOL opened=FALSE;
BOOL moving=FALSE;
float timer=0;
float timertoclose;

int ScriptMain(s_SC_OBJ_info *info){
	s_SC_NOD_transform trans;
	s_sphere sph;
	c_Vector3 vec,vec2;
	void *nod;
	float val;


	switch(info->event_type){
		case SC_OBJ_INFO_EVENT_INIT:
			SC_NOD_GetTransform(info->master_nod,&orig_trans);
			return TRUE;				
		case SC_OBJ_INFO_EVENT_JUSTLOADED:
			if (moving){
				trans=orig_trans;
				if (opened){
					trans.rot.z+=(1.57f*timer/OPENINGTIME);
				} else {
					trans.rot.z+=(1.57f*(OPENINGTIME-timer)/OPENINGTIME);
				}
				SC_NOD_SetTransform(info->master_nod,&trans);
			} else if (opened){
				trans=orig_trans;
				trans.rot.z+=1.57f;
				SC_NOD_SetTransform(info->master_nod,&trans);
			}

			break;

		case SC_OBJ_INFO_EVENT_RELEASE:
			SC_NOD_SetTransform(info->master_nod,&orig_trans);
			break;

		case SC_OBJ_INFO_EVENT_HIT:			
			break;

		case SC_OBJ_INFO_EVENT_DOTICK:			
			if (!SC_ggi(UNLOCKGV)) return 1;

			if (moving){
				timer+=info->time;
				trans=orig_trans;
				if (opened){
					trans.rot.z+=(1.57f*timer/OPENINGTIME);
				} else {
					trans.rot.z+=(1.57f*(OPENINGTIME-timer)/OPENINGTIME);
				}
				SC_NOD_SetTransform(info->master_nod,&trans);
				if (timer>OPENINGTIME) {
					moving=FALSE;
					timertoclose=AUTOCLOSETIME;
				}
			} else {
				if (opened){
					timertoclose-=info->time;
					if (timertoclose<0){
						SC_PC_GetPos(&vec);
						SC_NOD_GetWorldPos(info->master_nod,&vec2);
						if (!SC_IsNear2D(&vec,&vec2,AUTOCLOSEDISTANCE)){
							moving=TRUE;
							opened=!opened;
							timer=0;
							return FALSE;
						}
					}
				}
				val = SC_DOBJ_CameraLooksAt(info->master_nod,2.0f);
				if (val<1.0f){
					if (opened) SC_ACTIVE_Add(info->master_nod,2.0f*val,CLOSESTRING);
						else SC_ACTIVE_Add(info->master_nod,2.0f*val,OPENSTRING);
					return FALSE;
				}			
			}
			break;

		case SC_OBJ_INFO_EVENT_USED:
			moving=TRUE;
			opened=!opened;
			timer=0;
			if (opened){
				SC_NOD_GetWorldPos(info->master_nod,&vec2);
				SC_SND_PlaySound3D(CLOSESOUND,&vec);
			} else {
				SC_NOD_GetWorldPos(info->master_nod,&vec2);
				SC_SND_PlaySound3D(OPENSOUND,&vec);
			}
			break;

	}// switch(info->event_type)


	return FALSE;

}// int ScriptMain(s_OBJ_info *info)
