// Script helper script
// this is sample how to use script helpers - any AI player passing through the script helper will be forced to lie down and crawl


//sides 0 - US, 1 - VC, 100 anyone
#define ENABLEFORSIDE		0

//ONLY for the peace mode, players will NOT lie down if in battle
#define ONLYFORPEACE		1

#include <inc\sc_library.h>

#define MAXPLAYERS		64

typedef struct{
	int	side;
	int	group;
	int	member;
	int 	status;
	BOOL	resettobattle;
	float	resetphase;
	float 	timer;
}s_playerstat;

s_playerstat		P_Stats[MAXPLAYERS];
int actplayers=0;


void HandlePlayerIn(int pl, dword pl_id){		//handle player inside the sphere
	if (pl==666) return;			//invalid player or outside player, not in the list

	switch (P_Stats[pl].status){
	case 0:				//just entered
		SC_P_Ai_SetMode(pl_id,SC_P_AI_MODE_SCRIPT);
		SC_P_Ai_SetMovePos(pl_id,SC_P_AI_MOVEPOS_LIE);
		P_Stats[pl].status=1;
		P_Stats[pl].timer=2;		
		break;
	case 1:				//moving inside
		break;
	case 2:				//exited and returned
		SC_P_Ai_SetMode(pl_id,SC_P_AI_MODE_SCRIPT);
		SC_P_Ai_SetMovePos(pl_id,SC_P_AI_MOVEPOS_LIE);
		P_Stats[pl].status=1;
		P_Stats[pl].timer=2;
		break;
	}
}

void HandlePlayerOut(int pl, dword pl_id){		//handle player outside the sphere
	if (pl==666) return;			//invalid player or outside player, not in the list

	switch (P_Stats[pl].status){
	case 0:				//shouldn't be possible
		break;
	case 1:				//moving outside
	case 10:
		SC_P_Ai_SetMode(pl_id,P_Stats[pl].resettobattle);
		SC_P_Ai_SetMovePos(pl_id,P_Stats[pl].resetphase);
		P_Stats[pl].status=2;
		break;
	case 2:				//shouldn't be possible
		break;
	}
}

int LocatePlayer(s_SC_P_getinfo *pinfo, BOOL isinside){
	int i;
	
	for (i=0;i<actplayers;i++){
		if ((P_Stats[i].side==pinfo->side)&&(P_Stats[i].group==pinfo->group)&&(P_Stats[i].member==pinfo->member_id))
			return i;
	}
	//player not located
	if (!isinside) return 666;	//if player not inside, no point in addin
	
	//adding player to the list
	P_Stats[actplayers].side=pinfo->side;
	P_Stats[actplayers].group=pinfo->group;
	P_Stats[actplayers].member=pinfo->member_id;
	P_Stats[actplayers].status=0;
	P_Stats[actplayers].resettobattle=SC_P_Ai_GetMode(SC_P_GetBySideGroupMember(pinfo->side,pinfo->group,pinfo->member_id));
	P_Stats[actplayers].resetphase=SC_P_GetPhase(SC_P_GetBySideGroupMember(pinfo->side,pinfo->group,pinfo->member_id));
	actplayers++;			
	return (actplayers-1);
}

void PlayerDoTick(int pl, float timech){
	c_Vector3 vec;
	dword pl_id;
	
	P_Stats[pl].timer-=timech;
	pl_id=SC_P_GetBySideGroupMember(P_Stats[pl].side,P_Stats[pl].group,P_Stats[pl].member);
	
	if (ONLYFORPEACE && SC_P_Ai_GetSureEnemies(pl_id)){
		switch (P_Stats[pl].status){
		case 1:
		case 10:	
			SC_P_Ai_SetMode(pl_id,P_Stats[pl].resettobattle);
			SC_P_Ai_SetMovePos(pl_id,P_Stats[pl].resetphase);
			P_Stats[pl].status=2;
			break;
		}
		return;
	}
	
	switch (P_Stats[pl].status){
	case 1:				//inside
		if (P_Stats[pl].timer<0){
			P_Stats[pl].status=10;
			P_Stats[pl].timer=0.05f;
			switch (SC_P_Ai_GetPeaceMode(pl_id)){
			case SC_P_AI_PEACEMODE_HOLD:
				P_Battle(pl_id);
				break;
			case SC_P_AI_PEACEMODE_POINT:
				if (P_Stats[pl].member==1){
					if (SC_Ai_GetCurCheckPoint(P_Stats[pl].side,P_Stats[pl].group,&vec)){
						SC_P_Ai_Go(pl_id,&vec);
					} else P_Battle(pl_id);
				} else {
					SC_P_GetPos(SC_P_GetBySideGroupMember(P_Stats[pl].side,P_Stats[pl].group,1),&vec);
					SC_P_Ai_Go(pl_id,&vec);				
				}
				break;
			case SC_P_AI_PEACEMODE_FOLLOW:
				SC_PC_GetPos(&vec);
				SC_P_Ai_Go(pl_id,&vec);				
				break;
			default:
				P_Battle(pl_id);
				break;			
			}
		}
		break;
	case 10:				//end of battle tick
		if (P_Stats[pl].timer<0){
			P_Stats[pl].status=1;
			P_Stats[pl].timer=2.0f;
			P_Script(pl_id);
			SC_P_Ai_SetMovePos(pl_id,SC_P_AI_MOVEPOS_LIE);
		}
		break;
	}
}

float checktimer=0;

int ScriptMain(s_SC_ScriptHelper_info *info){	
	dword 		list[32];
	int		i,j;
	s_SC_P_getinfo 	pinfo;
	s_sphere		sph2;
	dword		scpc;
	
	
	switch(info->event_type){

		case SC_SCRHELPER_EVENTTYPE_INIT:				
			CLEAR(P_Stats);
			break;

		case SC_SCRHELPER_EVENTTYPE_RELEASE:				
			break;

		case SC_SCRHELPER_EVENTTYPE_TIMETICK:										
		checktimer-=info->elapsed_time;
		if (checktimer<0){
			checktimer=0.5f;
			i=32;
			SC_GetPls(&info->sph,list,&i);			
			scpc=SC_PC_Get();
			for (j=0;j<i;j++) {
				SC_P_GetInfo(list[j],&pinfo);
				if ((list[j]!=scpc)&&((pinfo.side==ENABLEFORSIDE)||(ENABLEFORSIDE==100))&&(SC_P_IsReady(list[j]))){
					if (!(ONLYFORPEACE&&SC_P_Ai_GetSureEnemies(list[j])))
						HandlePlayerIn(LocatePlayer(&pinfo,TRUE),list[j]);
				}
			}
			sph2 = info->sph;
			sph2.rad+=2;
			i=32;
			SC_GetPls(&sph2,list,&i);			
			for (j=0;j<i;j++) {
				SC_P_GetInfo(list[j],&pinfo);
				if ((!P_Near(list[j],&info->sph.pos,info->sph.rad))&&(list[j]!=scpc)&&((pinfo.side==ENABLEFORSIDE)||(ENABLEFORSIDE==100))&&(SC_P_IsReady(list[j]))){
					if (!(ONLYFORPEACE&&SC_P_Ai_GetSureEnemies(list[j])))
						HandlePlayerOut(LocatePlayer(&pinfo,FALSE),list[j]);
				}
			}
		}
		for (j=0;j<actplayers;j++) {
			if (P_Stats[j].resettobattle==SC_P_AI_MODE_BATTLE)
				PlayerDoTick(j,info->elapsed_time);
		}
		info->next_exe_time = 0.01f;
		break;
				
	}// switch(info->event_type)
				

	return 0;

}// int ScriptMain(s_SC_ScriptHelper_info *info)
